public class AlmeidaODE {

	public static void main(String[] args) {
		// states
		double n0 = 100.0, n1 = 0.0, n2 = 0.0, n3 = 0.0;
		double e0 = 0.0, e1 = 0.0, e2 = 0.0, e3 = 0.0;
		double memory = 0.0;
		double treg = 10.0;

		// input
		double inputNaive = 0.0, inputTReg = 0.0;

		// tcr prolif
		double tcrNaive = 0.02, tcrEffector = 0.02, tcrMemory = 0.05;
		double k = 1000;

		// il2 prolif
		double il2Effector = 0.00005, il2Memory = 0.00002, il2TReg = 0.0001;

		// differentiation
		double diff12 = 0.1, diff13 = 0.01, diff23 = 0.01, diff32 = 0.001;

		// suppression
		double b = 0.0002;

		// death
		double deathNaive = 0.001, deathEffector = 0.01, deathMemory = 0.01;

		// death treg
		double deathTReg = 0.01;
		double k2 = 10;

		// temporary state
		double n0_temp = 0.0, n1_temp = 0.0, n2_temp = 0.0, n3_temp = 0.0;
		double e0_temp = 0.0, e1_temp = 0.0, e2_temp = 0.0, e3_temp = 0.0;
		double memoryTemp = 0.0;
		double tregTemp = 0.0;

		for (int i = 0; i <= 24 * 14; i++) {
			System.out.println(i / 24 + " days and " + i % 24 + " hours");
			System.out.println("Naive0 : " + n0);
			System.out.println("Naive1 : " + n1);
			System.out.println("Naive2 : " + n2);
			System.out.println("Naive3 : " + n3);
			System.out.println("TOTAL NAIVE : " + (n0 + n1 + n2 + n3));
			System.out.println("Effector0 : " + e0);
			System.out.println("Effector1 : " + e1);
			System.out.println("Effector2 : " + e2);
			System.out.println("Effector3 : " + e3);
			System.out.println("TOTAL EFFECTOR : " + (e0 + e1 + e2 + e3));
			System.out.println("Memory : " + memory);
			System.out.println("TReg : " + treg);
			System.out.println();

			n0_temp = n0 + inputNaive - tcrNaive * n0 * (1 - (n0 + n1 + n2 + n3) / k) - deathNaive * n0;
			n1_temp = n1 + 2 * tcrNaive * n0 * (1 - (n0 + n1 + n2 + n3) / k)
					- tcrNaive * n1 * (1 - (n0 + n1 + n2 + n3) / k) - deathNaive * n1;
			n2_temp = n2 + 2 * tcrNaive * n1 * (1 - (n0 + n1 + n2 + n3) / k)
					- tcrNaive * n2 * (1 - (n0 + n1 + n2 + n3) / k) - deathNaive * n2;
			n3_temp = n3 + 2 * tcrNaive * n2 * (1 - (n0 + n1 + n2 + n3) / k)
					+ tcrNaive * n3 * (1 - (n0 + n1 + n2 + n3) / k) - deathNaive * n3 - diff12 * n3 - diff13 * n3;

			e0_temp = e0 + diff12 * n3 + diff32 * memory - tcrEffector * e0 * (1 - (e0 + e1 + e2 + e3) / k)
					- il2Effector * (e0 + e1 + e2 + e3) * e0 - deathEffector * e0 - b * e0 * treg;
			e1_temp = e1 + 2 * tcrEffector * e0 * (1 - (e0 + e1 + e2 + e3) / k)
					+ 2 * il2Effector * (e0 + e1 + e2 + e3) * e0 - tcrEffector * e1 * (1 - (e0 + e1 + e2 + e3) / k)
					- il2Effector * (e0 + e1 + e2 + e3) * e1 - deathEffector * e1 - b * e1 * treg;
			e2_temp = e2 + 2 * tcrEffector * e1 * (1 - (e0 + e1 + e2 + e3) / k)
					+ 2 * il2Effector * (e0 + e1 + e2 + e3) * e1 - tcrEffector * e2 * (1 - (e0 + e1 + e2 + e3) / k)
					- il2Effector * (e0 + e1 + e2 + e3) * e2 - deathEffector * e2 - b * e2 * treg;
			e3_temp = e3 + 2 * tcrEffector * e2 * (1 - (e0 + e1 + e2 + e3) / k)
					+ 2 * il2Effector * (e0 + e1 + e2 + e3) * e2 + tcrEffector * e3 * (1 - (e0 + e1 + e2 + e3) / k)
					+ il2Effector * (e0 + e1 + e2 + e3) * e3 - deathEffector * e3 - diff23 * e3 - b * e3 * treg;

			memoryTemp = memory + diff13 * n3 + diff23 * e3 + b * e0 * treg + b * e1 * treg + b * e2 * treg
					+ b * e3 * treg + tcrMemory * memory * (1 - memory / k) + il2Memory * (e0 + e1 + e2 + e3) * memory
					- deathMemory * memory - diff32 * memory;

			tregTemp = treg + inputTReg + il2TReg * (e0 + e1 + e2 + e3) * treg
					- deathTReg * k2 * treg / (k2 + (e0 + e1 + e2 + e3));

			n0 = n0_temp;
			n1 = n1_temp;
			n2 = n2_temp;
			n3 = n3_temp;

			e0 = e0_temp;
			e1 = e1_temp;
			e2 = e2_temp;
			e3 = e3_temp;

			memory = memoryTemp;

			treg = tregTemp;
		}
	}

}
