package goaml.lang.util;

import goaml.lang.state.State;
import goaml.mvc.model.SimulationModel;

public class DelayedUpdate {

	public enum Action {
		ADD, SUBSTRACT;
	}

	private final State STATE;
	private final Action ACTION;
	private final double VALUE;

	public DelayedUpdate(final State state, final Action action, final double value) {
		this.STATE = state;
		this.ACTION = action;
		this.VALUE = value;
	}

	public void apply() {
		switch (ACTION) {
		case ADD:
			STATE.add(VALUE*SimulationModel.getIntegralStep());
			break;

		case SUBSTRACT:
			STATE.substract(VALUE*SimulationModel.getIntegralStep());
			break;

		default:
			throw new RuntimeException("Unhandled action : " + ACTION);
		}
	}

}
