package goaml.mvc.view;

import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import goaml.mvc.model.SimulationModel;

public class AppView extends JFrame {

	private static final long serialVersionUID = 1L;

	public JTextField pathXMLTextField;
	public JButton browseXMLButton;

	public JTextField pathDriverTextField;
	public JButton browseDriverButton;
	public JButton deleteDriverButton;

	public JTextField durationTextField;
	public JTextField integrationTextField;
	public JComboBox<String> timeUnitComboBox;

	public JButton simulate;

	public JTextField pathCSVTextField;
	public JButton browseCSVButton;

	public JButton display;

	public AppView() {
		// Frame
		this.setTitle("Goaml");
		this.setLayout(new FlowLayout());
		this.add(new MainPanel());
		this.pack();
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setLocationRelativeTo(null);
		this.setVisible(true);
	}

	private class MainPanel extends JPanel {

		private static final long serialVersionUID = 1L;

		public static final int WIDTH = 700;
		public static final int HEIGHT = (int) (WIDTH / 16.0 * 9.0);

		private static final String pathXMLString = "Path of the XML file : ";
		private static final String pathDriverString = "Path of the driver file : ";
		private static final String browseString = "Browse...";
		private static final String deleteString = "Delete";
		private static final String stepsNumberString = "Number of time steps of the simulation : ";
		private static final String integrationInterval = "Integration time interval";
		private static final String simulateString = "Simulate";

		private static final String pathCSVString = "Path of the CSV file : ";
		private static final String displayString = "Display...";

		public MainPanel() {
			Dimension size = new Dimension(WIDTH, HEIGHT);
			this.setPreferredSize(size);
			this.setMinimumSize(size);
			this.setMaximumSize(size);
			this.setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));

			// Panel 1 - XML file
			JLabel pathXMLLabel = new JLabel(pathXMLString);
			pathXMLTextField = new JTextField(30);
			pathXMLLabel.setLabelFor(pathXMLTextField);
			pathXMLTextField.setEnabled(false);
			browseXMLButton = new JButton(browseString);
			deleteDriverButton = new JButton(deleteString);

			JPanel panel1 = new JPanel();
			panel1.setLayout(new FlowLayout(FlowLayout.LEFT));
			panel1.add(pathXMLLabel);
			panel1.add(pathXMLTextField);
			panel1.add(browseXMLButton);

			// Panel 2 - Driver
			JLabel pathDriverLabel = new JLabel(pathDriverString);
			pathDriverTextField = new JTextField(30);
			pathDriverLabel.setLabelFor(pathDriverTextField);
			pathDriverTextField.setEnabled(false);
			browseDriverButton = new JButton(browseString);

			JPanel panel2 = new JPanel();
			panel2.setLayout(new FlowLayout(FlowLayout.LEFT));
			panel2.add(pathDriverLabel);
			panel2.add(pathDriverTextField);
			panel2.add(browseDriverButton);
			panel2.add(deleteDriverButton);
			this.add(panel1);

			// Panel 3 - Duration
			JLabel durationLabel = new JLabel(stepsNumberString);
			durationTextField = new JTextField(10);
			durationLabel.setLabelFor(durationTextField);
			JLabel integrationLabel = new JLabel(integrationInterval);
			integrationTextField = new JTextField(10);
			integrationLabel.setLabelFor(integrationTextField);
			timeUnitComboBox = new JComboBox<String>();
			for (SimulationModel.TimeUnit tu : SimulationModel.TimeUnit.values()) {
				timeUnitComboBox.addItem(tu.toString());
			}

			JPanel panel3 = new JPanel();
			panel3.setLayout(new FlowLayout(FlowLayout.LEFT));
			panel3.add(durationLabel);
			panel3.add(durationTextField);
			panel3.add(integrationLabel);
			panel3.add(integrationTextField);
			//panel3.add(timeUnitComboBox);

			// Panel 4 - Simulate button
			simulate = new JButton(simulateString);

			JPanel panel4 = new JPanel();
			panel4.add(simulate);

			// Panel 5 - CSV File
			JLabel pathCSVLabel = new JLabel(pathCSVString);
			pathCSVTextField = new JTextField(30);
			pathCSVLabel.setLabelFor(pathCSVTextField);
			pathCSVTextField.setEnabled(false);
			browseCSVButton = new JButton(browseString);

			JPanel panel5 = new JPanel();
			panel5.setLayout(new FlowLayout(FlowLayout.LEFT));
			panel5.add(pathCSVLabel);
			panel5.add(pathCSVTextField);
			panel5.add(browseCSVButton);

			// Panel 6 - Simulate button
			display = new JButton(displayString);

			JPanel panel6 = new JPanel();
			panel6.add(display);

			this.add(panel1);
			this.add(panel2);
			this.add(panel3);
			this.add(panel4);
			this.add(panel5);
			this.add(panel6);
		}
	}

}
